                         'Pilot komputerowy
$crystal = 11059200                                           'Kwarc 11,0592MHz.
                                                              'Deklaracja zmiennych:
Dim Nowy As Bit                                               '  flaga nowego przycisku,
Dim E As Bit                                                  '  flaga klawisza specjalnego,
Dim P As Bit                                                  '  flaga parzystosci bajtu,
Dim Com As Byte                                               '  zmienna komendy pilota,
Dim Adr As Byte                                               '  zmienna adresu pilota,
Dim K As Byte                                                 '  zmienna kodu klawisza,
Dim X As Byte                                                 '  zmienna wysylanego bajtu,
Dim A As Byte                                                 '  zmienna pomocnicza A.
                                                              'Ustawienie aliasow:
Ziel Alias P1.0                                               '  LED zielona,
Czerw Alias P1.1                                              '  LED czerwona,
Dta Alias P1.2                                                '  linia KBDData,
Clk Alias P1.3                                                '  linia KBDClock,
Blk Alias P3.5                                                '  blokada klawiatury.
                                                              'Konfiguracja szyny I2C:
Config Sda = P3.0                                             '  konfiguracja linii SDA I2C,
Config Scl = P3.1                                             '  konfiguracja linii SCL I2C,
Config I2cdelay = 1                                           '  konfiguracja opoznienia I2C.
                                                              'Konfiguracja przerwan:
Reset Tcon.0                                                  '  przerwanie wyzwalane zboczem,
On Int0 Rc5                                                   '  przerwanie dla RC5,
Enable Int0                                                   '  wlaczenie przerwania Int0,
Enable Interrupts                                             '  wlaczenie przerwan.

Do                                                            'Petla.
  Bitwait Nowy , Set                                          'Oczekiwanie na nowa komede.
  Disable Int0                                                'Zablokowanie przerwania.
  Reset Nowy                                                  'Zresetowanie flagi nowego przycisku.
  I2cstart                                                    'Odczytywanie z EEPROM'u kodu klawisza
  I2cwbyte 160                                                'odpowiadajcego otrzymanej komendzie.
  I2cwbyte Com
  I2cstart
  I2cwbyte 161
  I2crbyte K , Nack
  I2cstop
  If K = &HFF Then                                            'Jesli przyciskowi nie odpowiadal zaden klawisz, to...
    Com = Com + 64                                            '  sprawdz, czy pod adresem o 64 wiekszym jest jakis kod.
    I2cstart
    I2cwbyte 160
    I2cwbyte Com
    I2cstart
    I2cwbyte 161
    I2crbyte K , Nack
    I2cstop
    If K <> &HFF Then                                         '  Jesli pod tym adresem byl jakis znak, to...
      Set E                                                   '     wlacz flage klawisza specjalnego.
    Else                                                      '  jesli nie, to...
      Reset Czerw : Waitms 240 : Set Czerw                    '     mignij czerwona dioda.
    End If
  End If
  If K <> &HFF Then                                           'Jesli udalo sie w koncu odczytac kod jakiegos przycisku, to...
    While Clk = 0                                             '  czekaj az linia klawiatury bedzie wolna.
      Waitms 2
    Wend                                                      '  Kiedy linia bdzie wolna...
    Reset Blk                                                 '  Zablokuj klawiature.
    If E = 1 Then                                             '  Jesli flaga specjalna byla wlaczona, to...
      Reset E                                                 '    zresetuj ja,
      X = &HE0                                                '    wyslij komputerowi kod klawisza specjalnego,
      Gosub Przeslij
      X = K                                                   '    wyslij komputerowi kod klawisza wcisnietego,
      Gosub Przeslij
      X = &HE0                                                '    wyslij komputerowi kod klawisza specjalnego,
      Gosub Przeslij
      X = &HF0                                                '    wyslij komputerowi kod puszczenia klawisza,
      Gosub Przeslij
      X = K                                                   '    wyslij komputerowi kod klawisza puszczonego.
      Gosub Przeslij
    Else                                                      '  Jesli jednak flaga specjalna byla wylaczona, to...
      X = K                                                   '    wyslij komputerowy kod klawisza wcisnietego,
      Gosub Przeslij
      X = &HF0                                                '    wyslij komputerowi kod puszczenia klawisza,
      Gosub Przeslij
      X = K                                                   '    wyslij komputerowi kod klawisza puszczonego.
      Gosub Przeslij
    End If
    Set Blk                                                   '  Odblokuj klawiature.
    Reset Ziel : Waitms 240 : Set Ziel                        '  Mignij zielona dioda.
  End If
  Enable Int0                                                 'Odblokowanie przerwanie.
Loop                                                          'Petla.

Przeslij:                                                     'Podprogram przesylajacy kod komputerowi:
  A = 0                                                       '  Sprawdzanie parzystosci bajtu przesylanego
  If X.0 = 1 Then : A = A + 1 : End If                        '  co bedzie potrzebne w czasie transmisji.
  If X.1 = 1 Then : A = A + 1 : End If                        '  Sprawdzanie to polega na policzeniu ilosci
  If X.2 = 1 Then : A = A + 1 : End If                        '  "jedynek" w danym bajcie a nastepnie
  If X.3 = 1 Then : A = A + 1 : End If                        '  sprawdzeniu, czy dzielenie tej liczby jedynek
  If X.4 = 1 Then : A = A + 1 : End If                        '  przez 2 daje jakas reszte.
  If X.5 = 1 Then : A = A + 1 : End If
  If X.6 = 1 Then : A = A + 1 : End If
  If X.7 = 1 Then : A = A + 1 : End If
  A = A Mod 2
  If A = 0 Then : Set P : Else : Reset P : End If
  Dta = 0 : Delay : Clk = 0 : Delay                           '  Przesylanie kodu komputerowi bit po bicie.
  Dta = X.0 : Clk = 1 : Delay : Clk = 0 : Delay
  Dta = X.1 : Clk = 1 : Delay : Clk = 0 : Delay
  Dta = X.2 : Clk = 1 : Delay : Clk = 0 : Delay
  Dta = X.3 : Clk = 1 : Delay : Clk = 0 : Delay
  Dta = X.4 : Clk = 1 : Delay : Clk = 0 : Delay
  Dta = X.5 : Clk = 1 : Delay : Clk = 0 : Delay
  Dta = X.6 : Clk = 1 : Delay : Clk = 0 : Delay
  Dta = X.7 : Clk = 1 : Delay : Clk = 0 : Delay
  Dta = P : Clk = 1 : Delay : Clk = 0 : Delay
  Dta = 1 : Clk = 1 : Delay : Clk = 0 : Delay : Clk = 1       '  Koniec przesylania kodu.
Return

Rc5:                                                          'Podprogram odbierajacy kod z pilota:
  Getrc5(adr , Com)                                           '  Odbieranie kodu RC5
  If Adr = 0 Then                                             '  Jesli adres jest rowny 0 (odpowiada naszemu pilotowi), to...
    Set Nowy                                                  '    ustaw flage nowego przycisku.
  Else                                                        '  Jesli jednak adres nie byl rowny 0, to...
    Reset Nowy                                                '    zrestuj flage nowego polecenia,
    Reset Czerw : Waitms 240 : Set Czerw                      '    mignij czerwona dioda.
  End If
Return
                                  'KONIEC